/*
 * : 2003/11/15
 *
 * 줿Ȥƥץ졼Ȥѹ뤿
 * ɥ >  > Java >  > ɤȥ
 */
package com.netpotlet.test;

import java.io.IOException;
import java.io.OutputStreamWriter;

import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.mapping.MappingException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import com.netpotlet.canoe.Key;
import com.netpotlet.canoe.Keyboard;
import com.netpotlet.canoe.Label;
import com.netpotlet.canoe.types.Type_list;

/**
 * @author yoko
 *
 * 줿Ȥƥץ졼Ȥѹ뤿
 * ɥ >  > Java >  > ɤȥ
 */
public class CastorCreator {
	private Keyboard keyboard;
	
	CastorCreator(String filename)
	    throws MarshalException,
	           ValidationException,
	           IOException, MappingException {
		keyboard = 
			(new CastorReader(filename)).getKeyboard();
		updateDocument();
		Marshaller marshaller =
		    new Marshaller(new OutputStreamWriter(System.out));
		marshaller.setEncoding("euc-jp");
		Mapping mapping = new Mapping();
		mapping.loadMapping("mapping.xml");
		marshaller.setMapping(mapping);
		marshaller.marshal(keyboard);
	}
	
	private void updateDocument() {
		String[] labels1 = {
			"", "", ""
		};
		String[] labels2 = {
			"", "", "", "", ""
		};
		Key key1 = (Key)keyboard.getKey(0);
		updateKey(key1, labels1);
		Key key2 = createKey(labels2);
		keyboard.addKey(2, key2);
	}
	
	private void updateKey(Key key,
                           String[] labels) {
        for (int i=0; i<labels.length; i++) {
			key.addLabel(getLabel(Type_list.CHARACTER, labels[i]));
        }
	}
	
	private Key createKey(String[] labels) {
		Key key = new Key();
		key.addLabel(getLabel(Type_list.NUMBER, "5"));
		for (int i=0; i<labels.length; i++) {
			key.addLabel(getLabel(Type_list.CHARACTER, labels[i]));
		}
		return key;
    }
	
	private Label getLabel(Type_list type,
	                       String text) {
		Label label = new Label();
		label.setAttrType(type);
		label.setContent(text);
		return label;
	}
	
	public static void main(String[] args) throws Exception {
		if (args.length < 1) {
			throw new Exception("arguments are not enough");
		}
		new CastorCreator(args[0]);
	}
}
